Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/ServiceLocator.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/ServiceLocator.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/ServiceLocator.cs	(revision 4629)
@@ -0,0 +1,59 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Services.Hive.Common.ServiceContracts;
+using HeuristicLab.Clients.Hive.Properties;
+
+namespace HeuristicLab.Clients.Hive {
+  internal class ServiceLocator {
+    private static ServiceLocator instance = null;
+    private ServiceClientFactory<IHiveService> serviceFactory = null;
+
+    public static ServiceLocator Instance {
+      get {
+        if (instance == null) {
+          instance = new ServiceLocator();
+        }
+        return instance;
+      }
+    }
+
+    public ServiceLocator() {
+      Settings.Default.SettingChanging += new System.Configuration.SettingChangingEventHandler(Default_SettingChanging);
+    }
+
+    private void Default_SettingChanging(object sender, System.Configuration.SettingChangingEventArgs e) {
+      if (serviceFactory != null) {
+        serviceFactory.Username = Settings.Default.HiveUsername;
+        serviceFactory.Password = Settings.Default.HivePassword;
+      }
+    }
+
+    public ServiceClientFactory<IHiveService> ServicePool {
+      get {
+        if (serviceFactory == null) {
+          serviceFactory = new ServiceClientFactory<IHiveService>(Settings.Default.HiveUsername, Settings.Default.HivePassword, "TcpEndpoint");
+        }
+        return serviceFactory;
+      }
+    }
+  }
+}
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Hive.sln
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Hive.sln	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Hive.sln	(revision 4629)
@@ -3,19 +3,8 @@
 # Visual Studio 2010
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Hive-3.3", "HeuristicLab.Hive\3.3\HeuristicLab.Hive-3.3.csproj", "{F98A1740-9AC9-4D36-A582-6A2D0D06978D}"
-	ProjectSection(ProjectDependencies) = postProject
-		{E1D6C801-892A-406A-B606-F158E36DD3C3} = {E1D6C801-892A-406A-B606-F158E36DD3C3}
-		{EC2C8109-6E1E-4C88-9A2B-908CFF2EF4AC} = {EC2C8109-6E1E-4C88-9A2B-908CFF2EF4AC}
-		{14424A16-48D4-445E-80BF-DDF617548BBB} = {14424A16-48D4-445E-80BF-DDF617548BBB}
-		{CF9DA321-AC1B-4FD3-9EC3-67BC6B861BDE} = {CF9DA321-AC1B-4FD3-9EC3-67BC6B861BDE}
-		{989FE92B-484E-41EE-87E2-6A24AF0381D8} = {989FE92B-484E-41EE-87E2-6A24AF0381D8}
-		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8} = {8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}
-		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB} = {B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}
-	EndProjectSection
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Clients.Hive.Slave-3.3", "HeuristicLab.Clients.Hive.Slave\3.3\HeuristicLab.Clients.Hive.Slave-3.3.csproj", "{989FE92B-484E-41EE-87E2-6A24AF0381D8}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Services.Hive.Common-3.3", "HeuristicLab.Services.Hive.Common\3.3\HeuristicLab.Services.Hive.Common-3.3.csproj", "{14424A16-48D4-445E-80BF-DDF617548BBB}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Services.Hive-3.3", "HeuristicLab.Services.Hive.Server\3.3\HeuristicLab.Services.Hive-3.3.csproj", "{CF9DA321-AC1B-4FD3-9EC3-67BC6B861BDE}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Services.Hive.DataAccess-3.3", "HeuristicLab.Services.Hive.DataAccess\3.3\HeuristicLab.Services.Hive.DataAccess-3.3.csproj", "{EC2C8109-6E1E-4C88-9A2B-908CFF2EF4AC}"
@@ -35,4 +24,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Clients.Hive.Slave.Views-3.3", "HeuristicLab.Clients.Hive.Slave.Views\3.3\HeuristicLab.Clients.Hive.Slave.Views-3.3.csproj", "{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Services.Hive-3.3", "HeuristicLab.Services.Hive\3.3\HeuristicLab.Services.Hive-3.3.csproj", "{CF9DA321-AC1B-4FD3-9EC3-67BC6B861BDE}"
 EndProject
 Global
@@ -54,8 +45,4 @@
 		{14424A16-48D4-445E-80BF-DDF617548BBB}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{14424A16-48D4-445E-80BF-DDF617548BBB}.Release|Any CPU.Build.0 = Release|Any CPU
-		{CF9DA321-AC1B-4FD3-9EC3-67BC6B861BDE}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{CF9DA321-AC1B-4FD3-9EC3-67BC6B861BDE}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{CF9DA321-AC1B-4FD3-9EC3-67BC6B861BDE}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{CF9DA321-AC1B-4FD3-9EC3-67BC6B861BDE}.Release|Any CPU.Build.0 = Release|Any CPU
 		{EC2C8109-6E1E-4C88-9A2B-908CFF2EF4AC}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{EC2C8109-6E1E-4C88-9A2B-908CFF2EF4AC}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -74,4 +61,8 @@
 		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Release|Any CPU.Build.0 = Release|Any CPU
+		{CF9DA321-AC1B-4FD3-9EC3-67BC6B861BDE}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{CF9DA321-AC1B-4FD3-9EC3-67BC6B861BDE}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{CF9DA321-AC1B-4FD3-9EC3-67BC6B861BDE}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{CF9DA321-AC1B-4FD3-9EC3-67BC6B861BDE}.Release|Any CPU.Build.0 = Release|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Hive/3.3/HeuristicLab.Hive-3.3.csproj
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Hive/3.3/HeuristicLab.Hive-3.3.csproj	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Hive/3.3/HeuristicLab.Hive-3.3.csproj	(revision 4629)
@@ -32,4 +32,10 @@
     <WarningLevel>4</WarningLevel>
   </PropertyGroup>
+  <PropertyGroup>
+    <SignAssembly>true</SignAssembly>
+  </PropertyGroup>
+  <PropertyGroup>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
   <ItemGroup>
     <Reference Include="HeuristicLab.Common-3.3">
@@ -57,11 +63,15 @@
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
     <PostBuildEvent>set ProjectName=$(ProjectName)
 set TargetPath=$(TargetPath)
+set TargetDir=$(TargetDir)
 set SolutionDir=$(SolutionDir)
-call $(SolutionDir)/MergeConfigs.cmd
-call $(SolutionDir)/CopyAssembly.cmd</PostBuildEvent>
+call $(SolutionDir)/CopyAssembly.cmd
+call $(SolutionDir)/MergeConfigs.cmd</PostBuildEvent>
   </PropertyGroup>
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/Appointment.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/Appointment.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/Appointment.cs	(revision 4629)
@@ -22,4 +22,5 @@
 using System;
 using System.Runtime.Serialization;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
@@ -38,4 +39,15 @@
     [DataMember]
     public Guid ResourceId { get; set; }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      Appointment clone = (Appointment)base.Clone(cloner);
+      clone.AllDayEvent = this.AllDayEvent;
+      clone.EndDate = this.EndDate;
+      clone.Recurring = this.Recurring;
+      clone.RecurringId = this.RecurringId;
+      clone.ResourceId = this.ResourceId;
+      clone.StartDate = this.StartDate;
+      return clone;
+    }
   }
 }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/HeartBeat.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/HeartBeat.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/HeartBeat.cs	(revision 4629)
@@ -27,5 +27,5 @@
 
   [DataContract]
-  public class HeartBeat {
+  public class Heartbeat {
     [DataMember]
     public Guid SlaveId { get; set; }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/HiveExperiment.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/HiveExperiment.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/HiveExperiment.cs	(revision 4629)
@@ -39,6 +39,11 @@
       return base.ToString() + "Name: " + Name + ", Description: " + Description + ", ResourceIds: " + ResourceIds;
     }
-
-    public HiveExperiment() {
+    
+    public override IDeepCloneable Clone(Cloner cloner) {
+      var clone = (HiveExperiment)base.Clone(cloner);
+      clone.ResourceIds = this.ResourceIds;
+      clone.RootJobId = this.RootJobId;
+      clone.UserId = this.UserId;
+      return clone;
     }
   }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/HiveItem.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/HiveItem.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/HiveItem.cs	(revision 4629)
@@ -4,10 +4,22 @@
 using System.Text;
 using System.Runtime.Serialization;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
   [DataContract]
-  public abstract class HiveItem {
+  public abstract class HiveItem : IDeepCloneable {
     [DataMember]
     public Guid Id { get; set; }
+
+    public virtual IDeepCloneable Clone(Cloner cloner) {
+      HiveItem clone = (HiveItem)Activator.CreateInstance(this.GetType(), true);
+      cloner.RegisterClonedObject(this, clone);
+      clone.Id = this.Id;
+      return clone;
+    }
+
+    public object Clone() {
+      return Clone(new Cloner());
+    }
   }
 }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/HivePlugin.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/HivePlugin.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/HivePlugin.cs	(revision 4629)
@@ -24,4 +24,5 @@
 using System.Linq;
 using System.Runtime.Serialization;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
@@ -32,5 +33,12 @@
     public Version Version { get; set; }
     [DataMember]
-    public Boolean Update { get; set; }
+    public bool Update { get; set; }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      var clone = (HivePlugin)base.Clone(cloner);
+      clone.Version = this.Version;
+      clone.Update = this.Update;
+      return clone;
+    }
   }
 }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/HivePluginData.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/HivePluginData.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/HivePluginData.cs	(revision 4629)
@@ -22,4 +22,5 @@
 using System;
 using System.Runtime.Serialization;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
@@ -34,4 +35,10 @@
       Name = name;
     }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      var clone = (HivePluginData)base.Clone(cloner);
+      if (this.Data != null) clone.Data = new byte[this.Data.Length]; Array.Copy(this.Data, clone.Data, this.Data.Length);
+      return clone;
+    }
   }
 }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/Job.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/Job.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/Job.cs	(revision 4629)
@@ -55,4 +55,16 @@
       AssignedResourceIds = new List<Guid>();
     }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      var clone = (Job)base.Clone(cloner);
+      clone.UserId = this.UserId;
+      clone.Priority = this.Priority;
+      clone.CoresNeeded = this.CoresNeeded;
+      clone.MemoryNeeded = this.MemoryNeeded;
+      clone.PluginsNeededIds = new List<Guid>(this.PluginsNeededIds);
+      clone.AssignedResourceIds = new List<Guid>(this.AssignedResourceIds);
+      clone.ProjectId = this.ProjectId;
+      return clone;
+    }
   }
 }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/JobData.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/JobData.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/JobData.cs	(revision 4629)
@@ -23,4 +23,5 @@
 using System.IO;
 using System.Runtime.Serialization;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
@@ -32,4 +33,10 @@
     [DataMember]
     public byte[] Data { get; set; }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      var clone = (JobData)base.Clone(cloner);
+      if (this.Data != null) clone.Data = new byte[this.Data.Length]; Array.Copy(this.Data, clone.Data, this.Data.Length);
+      return clone;
+    }
   }
 }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/LightweightJob.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/LightweightJob.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/LightweightJob.cs	(revision 4629)
@@ -22,4 +22,5 @@
 using System;
 using System.Runtime.Serialization;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
@@ -56,4 +57,17 @@
       this.ParentJobId = job.ParentJobId;
     }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      var clone = (LightweightJob)base.Clone(cloner);
+      clone.SlaveId = this.SlaveId;
+      clone.State = this.State;
+      clone.ExecutionTime = this.ExecutionTime;
+      clone.Exception = this.Exception;
+      clone.DateCreated = this.DateCreated;
+      clone.DateCalculated = this.DateCalculated;
+      clone.DateFinished = this.DateFinished;
+      clone.ParentJobId = this.ParentJobId;
+      return clone;
+    }
   }
 }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/NamedHiveItem.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/NamedHiveItem.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/NamedHiveItem.cs	(revision 4629)
@@ -4,4 +4,5 @@
 using System.Text;
 using System.Runtime.Serialization;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
@@ -12,4 +13,11 @@
     [DataMember]
     public string Description { get; set; }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      var clone = (NamedHiveItem)base.Clone(cloner);
+      clone.Name = this.Name;
+      clone.Description = this.Description;
+      return clone;
+    }
   }
 }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/Slave.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/Slave.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/Slave.cs	(revision 4629)
@@ -29,7 +29,7 @@
   public class Slave : Resource {
     [DataMember]
-    public int? NrOfCores { get; set; }
+    public int? Cores { get; set; }
     [DataMember]
-    public int? NrOfFreeCores { get; set; }
+    public int? FreeCores { get; set; }
     [DataMember]
     public int? CpuSpeedPerCore { get; set; }
@@ -39,16 +39,28 @@
     public int? FreeMemory { get; set; }
     [DataMember]
-    public DateTime? Login { get; set; }
-    [DataMember]
     public SlaveState State { get; set; }
     [DataMember]
     public CalendarState CalendarSyncStatus { get; set; }
     [DataMember]
-    public SlaveConfig Config { get; set; }
+    public Guid SlaveConfigId { get; set; }
     [DataMember]
     public bool IsAllowedToCalculate { get; set; }
 
     public override string ToString() {
-      return base.ToString() + ", NrOfCores: " + NrOfCores + ", NrOfFreeCores " + NrOfFreeCores + ", Login: " + Login + ", State: " + State;
+      return base.ToString() + ", NrOfCores: " + Cores + ", NrOfFreeCores " + FreeCores + ", State: " + State;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      var clone = (Slave)base.Clone(cloner);
+      clone.Cores = this.Cores;
+      clone.FreeCores = this.FreeCores;
+      clone.CpuSpeedPerCore = this.CpuSpeedPerCore;
+      clone.Memory = this.Memory;
+      clone.FreeMemory = this.FreeMemory;
+      clone.State = this.State;
+      clone.CalendarSyncStatus = this.CalendarSyncStatus;
+      clone.SlaveConfigId = this.SlaveConfigId;
+      clone.IsAllowedToCalculate = this.IsAllowedToCalculate;
+      return clone;
     }
   }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/SlaveConfig.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/SlaveConfig.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/SlaveConfig.cs	(revision 4629)
@@ -32,4 +32,11 @@
     [DataMember]
     public int? HeartBeatIntervall { get; set; }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      var clone = (SlaveConfig)base.Clone(cloner);
+      clone.UpDownTimeCalendar = this.UpDownTimeCalendar;
+      clone.HeartBeatIntervall = this.HeartBeatIntervall;
+      return clone;
+    }
   }
 }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/SlaveGroup.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/SlaveGroup.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/SlaveGroup.cs	(revision 4629)
@@ -23,4 +23,6 @@
 using System.Linq;
 using System.Runtime.Serialization;
+using System;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
@@ -28,8 +30,14 @@
   public class SlaveGroup : Resource {
     [DataMember]
-    public List<Resource> Resources { get; set; }
+    public List<Guid> ResourcesIds { get; set; }
 
     public SlaveGroup() {
-      Resources = new List<Resource>();
+      ResourcesIds = new List<Guid>();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      var clone = (SlaveGroup)base.Clone(cloner);
+      clone.ResourcesIds = new List<Guid>(this.ResourcesIds);
+      return clone;
     }
   }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/SlaveState.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/SlaveState.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/SlaveState.cs	(revision 4629)
@@ -23,5 +23,4 @@
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
   public enum SlaveState {
-    NullState,
     Idle,
     Calculating,
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/UpTimeStatistics.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/UpTimeStatistics.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/UpTimeStatistics.cs	(revision 4629)
@@ -22,4 +22,5 @@
 using System;
 using System.Runtime.Serialization;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
@@ -27,9 +28,17 @@
   public class UpTimeStatistics : HiveItem {
     [DataMember]
-    public Slave Slave { get; set; }
+    public Guid SlaveId { get; set; }
     [DataMember]
     public DateTime Login { get; set; }
     [DataMember]
     public DateTime Logout { get; set; }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      var clone = (UpTimeStatistics)base.Clone(cloner);
+      clone.SlaveId = this.SlaveId;
+      clone.Login = this.Login;
+      clone.Logout = this.Logout;
+      return clone;
+    }
   }
 }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/HeuristicLab.Services.Hive.Common-3.3.csproj
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/HeuristicLab.Services.Hive.Common-3.3.csproj	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/HeuristicLab.Services.Hive.Common-3.3.csproj	(revision 4629)
@@ -30,4 +30,10 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup>
+    <SignAssembly>true</SignAssembly>
+  </PropertyGroup>
+  <PropertyGroup>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
   </PropertyGroup>
   <ItemGroup>
@@ -81,4 +87,7 @@
     <Compile Include="ServiceContracts\IHiveService.cs" />
   </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/MessageContainer.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/MessageContainer.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/MessageContainer.cs	(revision 4629)
@@ -43,5 +43,5 @@
       JobFailed, 
       UptimeLimitDisconnect,
-      FetchOrForceFetchCalendar, 
+      UpdateCalendar, 
       AddChildJob,
       PauseJob,
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/ServiceContracts/IHiveService.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/ServiceContracts/IHiveService.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/ServiceContracts/IHiveService.cs	(revision 4629)
@@ -6,10 +6,11 @@
 using System.IO;
 using HeuristicLab.Services.Hive.Common.DataTransfer;
+using System.Net.Security;
 
 namespace HeuristicLab.Services.Hive.Common.ServiceContracts {
+
+  [ServiceContract(ProtectionLevel = ProtectionLevel.EncryptAndSign)]
   public interface IHiveService {
 
-    // todo: Rename:
-    //  Result is ambiguous; sometimes it refers to a serialized job which has finished, sometimes it is the current state of the job
     #region Job Methods
     [OperationContract]
@@ -81,4 +82,7 @@
 
     #region HiveExperiment Methods
+    [OperationContract]
+    HiveExperiment GetHiveExperiment(Guid id);
+
     /// <summary>
     /// Returns all experiments for the current user
@@ -86,4 +90,7 @@
     [OperationContract]
     IEnumerable<HiveExperiment> GetHiveExperiments();
+
+    [OperationContract]
+    Guid AddHiveExperiment(HiveExperiment hiveExperimentDto);
 
     [OperationContract]
@@ -113,18 +120,18 @@
     /// </summary>
     /// <returns></returns>
-    [OperationContract]
-    void Login();
-    /// <summary>
-    /// This method registers the slave and marks it as online
-    /// </summary>
-    [OperationContract]
-    void Login(Slave slave);
-    [OperationContract]
-    void Logout(Guid clientId);
+    //[OperationContract]
+    //void Login();
+    ///// <summary>
+    ///// This method registers the slave and marks it as online
+    ///// </summary>
+    //[OperationContract]
+    //void Login(Slave slave);
+    //[OperationContract]
+    //void Logout(Guid clientId);
     #endregion
 
     #region Heartbeat Methods
     [OperationContract]
-    List<MessageContainer> ProcessHeartBeat(HeartBeat heartbeat);
+    List<MessageContainer> ProcessHeartbeat(Heartbeat heartbeat);
     #endregion
 
@@ -138,5 +145,5 @@
     #region Calendar Methods
     [OperationContract]
-    IEnumerable<Appointment> GetCalendar(Guid clientId);
+    IEnumerable<Appointment> GetCalendar(Guid slaveId);
     [OperationContract]
     void SetCalendarStatus(Guid clientId, CalendarState state);
@@ -171,4 +178,7 @@
     [OperationContract]
     void RemoveResourceFromGroup(Guid slaveGroupId, Guid resourceId);
+
+    [OperationContract]
+    void UpdateSlave(Slave slave);
     #endregion
     
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/ContextFactory.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/ContextFactory.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/ContextFactory.cs	(revision 4629)
@@ -75,5 +75,5 @@
           transactions.Add(threadId, transaction);
         }
-        return context;
+        return disposableContext;
       }
     }
@@ -96,5 +96,5 @@
       lock (locker) {
         int threadId = Thread.CurrentThread.ManagedThreadId;
-        contexts[threadId].Dispose();
+        contexts[threadId].Obj.Dispose();
         contexts.Remove(threadId);
         // context gets disposed implicitly, when it is used as IDisposable
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HeuristicLab.Services.Hive.DataAccess-3.3.csproj
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HeuristicLab.Services.Hive.DataAccess-3.3.csproj	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HeuristicLab.Services.Hive.DataAccess-3.3.csproj	(revision 4629)
@@ -30,4 +30,10 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup>
+    <SignAssembly>true</SignAssembly>
+  </PropertyGroup>
+  <PropertyGroup>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
   </PropertyGroup>
   <ItemGroup>
@@ -75,4 +81,5 @@
       <DependentUpon>Settings.settings</DependentUpon>
     </Compile>
+    <Compile Include="Tools\CreateHiveDatabaseApplication.cs" />
   </ItemGroup>
   <ItemGroup>
@@ -83,4 +90,5 @@
       <SubType>Designer</SubType>
     </None>
+    <None Include="HeuristicLab.snk" />
     <None Include="HiveDataContext.dbml">
       <Generator>MSLinqToSQLGenerator</Generator>
@@ -104,4 +112,8 @@
     </ProjectReference>
   </ItemGroup>
+  <ItemGroup>
+    <Content Include="Tools\cleanHiveDatabase.sql" />
+    <Content Include="Tools\prepareHiveDatabase.sql" />
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
